require File.dirname(__FILE__) + '/../test_helper'
require 'admincontactgroup_controller'

# Re-raise errors caught by the controller.
class AdmincontactgroupController; def rescue_action(e) raise e end; end

class AdmincontactgroupControllerTest < Test::Unit::TestCase
  fixtures :contactgroups

  def setup
    @controller = AdmincontactgroupController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = contactgroups(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:contactgroups)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:contactgroup)
    assert assigns(:contactgroup).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:contactgroup)
  end

  def test_create
    num_contactgroups = Contactgroup.count

    post :create, :contactgroup => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_contactgroups + 1, Contactgroup.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:contactgroup)
    assert assigns(:contactgroup).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      Contactgroup.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      Contactgroup.find(@first_id)
    }
  end
end
